searchNodes=[{"ref":"Mix.Tasks.Horn.html","title":"Mix.Tasks.Horn","module":"Mix.Tasks.Horn","type":"task","doc":"Prints Horn tasks and their information. mix horn Prints Horn version. mix horn -v"},{"ref":"Mix.Tasks.Horn.New.html","title":"Mix.Tasks.Horn.New","module":"Mix.Tasks.Horn.New","type":"task","doc":"Creates a new Horn-Flask project. It expects the path of the project as an argument. mix horn.new PATH [--app APP] A project at the given PATH will be created. The default app folder name is &quot;app&quot; unless --app is given. Options --app - the name of the application folder. default value is app --proj - the name of the project, the default value is the capitalized given PATH. for example, if the PATH is foo_bar, the default project name is FooBar --pypi - the mirror of pypi, eg: pypi.doubanio.com --bare - if set, horn will create a bare project without user module Example mix horn.new foo_bar --app foobar --pypi=pypi.doubanio.com --bare the project directory structure looks like: . ├── foobar │ ├── config │ │ └── ... │ ├── core │ │ └── ... │ ├── models │ │ └── ... │ ├── schemas │ │ └── ... │ ├── views │ │ └── ... │ └── .... ├── instance │ └── ... ├── log/ ├── test │ └── ... ├── Pipfile ├── README.md └── ... you will find: app - the app folder is renamed to foobar. Pipfile - in section [[source]], the url become https://pypi.doubanio.com/simple README.md - the project name is FooBar"},{"ref":"readme.html","title":"Horn","module":"readme","type":"extras","doc":"Horn A weird Flask scaffolding tool for building restful-server, writen in Elixir Documentation"},{"ref":"readme.html#prerequisites","title":"Horn - Prerequisites","module":"readme","type":"extras","doc":"horn implemented in elixir language, so you should install elixir first: $ brew install elixir In python side, Horn recommend manages python packages via pipenv $ pip install pipenv"},{"ref":"readme.html#installation","title":"Horn - Installation","module":"readme","type":"extras","doc":"Install horn by using the build tool mix. Lastest release version: $ mix archive.install hex horn"},{"ref":"readme.html#create-your-flask-app","title":"Horn - Create your Flask app","module":"readme","type":"extras","doc":"Now, enjoy with Flask: $ mix horn.new YOUR_APP_NAME"},{"ref":"quickstart.html","title":"Quickstart","module":"quickstart","type":"extras","doc":"Quickstart After installed Horn, we can run mix horn.new to create our flask application. In this tutorial, we create a simple application named blog: $ mix horn.new blog * creating blog/Pipfile * creating blog/README.md * creating blog/pytest.ini ... * creating blog/test/views/test_user.py * creating blog/test/views/test_session.py Fetch and install dependencies? [Yn] Horn generates all files necessary for our project. then it will ask us if we want install dependencies. we choose [y] Fetch and install dependencies? [Yn] y * running pipenv install --dev Creating a virtualenv for this project… ... ... ✔ Successfully created virtual environment! ... Pipfile.lock not found, creating… Locking [dev-packages] dependencies… ⠋ Locking..✔ Success! Locking [packages] dependencies… ⠹ Locking..✔ Success! Updated Pipfile.lock (5dbc0e)! Installing dependencies from Pipfile.lock (5dbc0e)… To activate this project&#39;s virtualenv, run pipenv shell. Alternatively, run a command inside the virtualenv with pipenv run. We are almost there! The following steps are missing: $ cd blog Then configure your flask environment variables: $ export FLASK_ENV=development $ export FLASK_APP=app And configure your database in app/config/development.py and run $ flask db init $ flask db migrate -m &quot;init&quot; $ flask db upgrade Start your flask app with: $ pipenv run flask run OK, let&#39;s try it. follow the steps above: ... ... $ pipenv shell ... ... (blog) $ flask run * Serving Flask app &quot;app&quot; (lazy loading) * Environment: development * Debug mode: on * Running on http://127.0.0.1:5000/ (Press CTRL+C to quit) * Restarting with stat * Debugger is active! * Debugger PIN: 173-964-918 By default, flask application accept requests on port 5000, we should open web browser to access url http://localhost:5000/api, or by using curl http://localhost:5000/api on console, then we will see the welcome message: {&quot;message&quot;: &quot;Hello visitor, Welcome to Blog!&quot;} At last, Open your browser and visit http://localhost:5000/spec, all of our APIs are shown in this page. We can browse and try them easily. Unit Testing The application created by Horn contains sample unit tests. Let&#39;s run tests: (blog) $ pytest ... collected 10 items test/test_swagger.py::TestSwagger::test_swagger PASSED test/views/test_home.py::TestHome::test_home PASSED ... test/views/test_user.py::TestUser::test_update PASSED test/views/test_user.py::TestUser::test_delete PASSED ... ... Not bad, all tests passed! Production Mode To run application in production mode, try this: (blog) $ FLASK_ENV=production FLASK_APP=app flask run We will see output similar to this: * Serving Flask app &quot;app&quot; * Environment: production WARNING: Do not use the development server in a production environment. Use a production WSGI server instead. * Debug mode: off note In production mode, Hron disabled swagger UI"},{"ref":"structure.html","title":"Project Structure","module":"structure","type":"extras","doc":"Project Structure If we create application with default options, the top-level directory structure like this: . ├── app/ │ ├── config/ │ ├── core/ │ ├── models/ │ ├── schemas/ │ ├── views/ │ └── ... ├── instance/ ├── log/ ├── test/ ├── Pipfile ├── Pipfile.lock ├── README.md ├── logging.ini └── pytest.ini Horn consider such a structure is best practice for flask application. app/ - main directory contains most of the codes instance/ - contains secret config that MUST NOT be committed to VCS test/ - contains unit test codes log/ - the default directory to store log files Pipfile Pipfile.lock - generated by pipenv logging.ini - configure file for logging pytest.ini - configure file for pytest README.md - simple notes about this project As you can see, most of the codes will placed in the app folder, It looks like this when expanded: . ├── config │ ├── __init__.py │ ├── default.py │ ├── development.py │ ├── production.py │ └── testing.py ├── core │ ├── __init__.py │ ├── database.py │ ├── errors.py │ └── schema.py ├── models │ ├── __init__.py │ ├── helpers.py │ └── user.py ├── schemas │ ├── __init__.py │ ├── helpers.py │ └── user.py ├── views │ ├── __init__.py │ ├── home.py │ ├── session.py │ └── user.py ├── __init__.py ├── cmds.py ├── exts.py ├── helpers.py ├── router.py ├── run.py └── swagger.py config/ - configures of our application core/ - provide core functions models/ - models created through sqlalchemy saved here, and Horn provide some helper functions for model in helpers.py schemas/ - schemas created through marshmallow saved here, and Horn provide some helper functions for schema in helpers.py views/ - views more like controllers in other mvc frameworks, contains most of the bussiness layer codes. home.py performs a hello world as example cmds.py - custom flask commands saved here exts.py - flask extensions configures saved here helpers.py - global helper functions router.py - the application&#39;s routers saved here, in flask, also called blueprints run.py - the entry of the application swagger.py - swagger configures saved here"}]